<template>
  <div class="p-4">
    <BasicTable @register="registerTable">
      <template #toolbar>
        <a-button
          v-power="[RoleEnum.COMPANY_ADMIN, RoleEnum.PLAT_ADMIN]"
          type="primary"
          @click="handleCreate"
          >新增</a-button
        >
      </template>
      <template #headerTop v-if="getCheckRole([RoleEnum.COMPANY_ADMIN])">
        <Alert
          :message="`可新增带看员工为 ${surplusSubNum.lookNum} 个、拍摄员工为 ${surplusSubNum.shotNum} 个`"
          type="info"
        />
      </template>
      <template #role="{ record }">
        {{ renderRoleType(record.role) }}
      </template>
      <template #status="{ record }">
        {{ renderStatus(record.status) }}
      </template>
      <template #createTime="{ record }">
        <Time :value="record.createTime" mode="datetime" />
      </template>
      <!-- , -->
      <template #action="{ record }">
        <TableAction
          :actions="[
            {
              label: '编辑',
              onClick: handleEdit.bind(null, record),
            },
            {
              color: 'warning',
              label: t('routes.staff.setpaswd'),
              onClick: handleOpenModal.bind(null, record),
            },
            {
              label: '删除',
              color: 'error',
              popConfirm: {
                title: '是否确认删除',
                confirm: handleDelete.bind(null, record),
              },
            },
          ]"
        />
      </template>
    </BasicTable>
    <DetailsModal @register="registerDetail" @ok="reloadList" />
    <SetpaswordModal @register="register" @reload="reloadList" />
    <DelListModal @register="registerDelList" @reload="reloadList" />
  </div>
</template>
<script lang="ts">
  import { defineComponent, computed, onMounted, ref } from 'vue';
  import { BasicTable, useTable, BasicColumn, FormProps, TableAction } from '/@/components/Table';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { useModal } from '/@/components/Modal';
  import { uploadApi } from '/@/api/sys/upload';
  import SetpaswordModal from './setpaswordModal.vue';
  import DetailsModal from './detailsModal.vue';
  import DelListModal from './delListModal.vue';
  import { Alert } from 'ant-design-vue';
  // import { h } from 'vue';
  import { ListApi, delApi, preDelApi, getNumByStaff } from '/@/api/staff/list';
  import { useI18n } from '/@/hooks/web/useI18n';
  // import { useCopyToClipboard } from '/@/hooks/web/useCopyToClipboard';
  import { RoleEnum } from '/@/enums/roleEnum';
  import { useGo } from '/@/hooks/web/usePage';
  import { Time } from '/@/components/Time';
  import { useUserStore } from '/@/store/modules/user';
  export default defineComponent({
    components: {
      BasicTable,
      TableAction,
      Time,
      SetpaswordModal,
      DetailsModal,
      DelListModal,
      Alert,
    },
    setup() {
      const [register, { openModal }] = useModal();
      const surplusSubNum = ref({
        lookNum: 0,
        shotNum: 0,
      });
      const [registerDetail, { openModal: openDetaileModal }] = useModal();
      const [registerDelList, { openModal: openDelListeModal }] = useModal();
      const { createConfirm, createMessage } = useMessage();
      const userStore = useUserStore();
      const { getCheckRole } = userStore;
      const roleList = computed(() => userStore.getRoleList);
      console.log('getRoleList', roleList);
      const go = useGo();
      const { t } = useI18n();
      onMounted(() => {
        getNumByStaffData();
      });

      const columns: BasicColumn[] = [
        {
          title: 'ID',
          dataIndex: 'id',
          fixed: 'left',
          width: 60,
        },
        {
          title: t('routes.staff.deptName'),
          dataIndex: 'companyName',
          width: 160,
        },
        // {
        //   title: t('routes.staff.userName'),
        //   dataIndex: 'userName',
        //   width: 80,
        // },
        {
          title: t('routes.staff.userName'),
          dataIndex: 'nickName',
          width: 80,
        },
        {
          title: '手机',
          dataIndex: 'phone',
          width: 160,
        },

        {
          title: t('common.roleName'),
          dataIndex: 'roleName',
          // slots: { customRender: 'role' },
          sorter: true,
          width: 80,
        },
        // {
        //   title: t('common.state'),
        //   dataIndex: 'status',
        //   slots: { customRender: 'status' },
        //   // sorter: true,
        //   width: 80,
        // },

        {
          title: t('routes.staff.createTime'),
          dataIndex: 'createTime',
          slots: { customRender: 'createTime' },
          width: 130,
        },
        {
          title: '操作',
          dataIndex: '',
          ifShow: !getCheckRole('tourist'),
          slots: { customRender: 'action' },
          fixed: 'right',
          width: 150,
        },
      ];

      const searchForm: Partial<FormProps> = {
        labelWidth: 100,
        schemas: [
          {
            field: 'staffName',
            label: t('routes.corporation.phone'),
            component: 'Input',
            componentProps: {
              maxLength: 15,
            },
            colProps: {
              xl: 5,
              xxl: 5,
            },
          },
        ],
      };

      const [registerTable, { reload }] = useTable({
        title: t('routes.staff.staffList'),
        api: ListApi,
        columns: columns,
        useSearchForm: true,
        formConfig: searchForm,
        showTableSetting: true,
        tableSetting: { fullScreen: true },
        showIndexColumn: false,
        rowKey: 'id',
        pagination: { pageSize: 20 },
        afterFetch: (T) => {
          console.log('afterFetch', T);
          return T;
        },
        bordered: true,
        sortFn: (sortInfo) => {
          let order = sortInfo.order && sortInfo.order.replace('end', '');
          return { ...sortInfo, sidx: sortInfo.field, order: order };
        },
      });

      function renderRoleType(type: number): string {
        switch (type) {
          case 0:
            return t('routes.staff.roleType.0');
          case 1:
            return t('routes.staff.roleType.1');
          default:
            return '';
        }
      }
      function renderStatus(type: number): string {
        switch (type) {
          case 1:
            return t('common.normal');
          case 0:
            return t('common.unNormal');
          default:
            return '';
        }
      }
      function handleOpenModal(record: Recordable) {
        openModal(true, record);
      }
      function handleCreate() {
        if (
          getCheckRole([RoleEnum.COMPANY_ADMIN]) &&
          surplusSubNum.value.lookNum == 0 &&
          surplusSubNum.value.shotNum == 0
        ) {
          return createMessage.error('新增失败，可添加员工数量为0个');
        }
        openDetaileModal(true, {});
      }
      function handleEdit(record: Recordable) {
        openDetaileModal(true, record);
      }
      function getNumByStaffData() {
        getNumByStaff({}).then((res) => {
          surplusSubNum.value.lookNum = res.lookNum;
          surplusSubNum.value.shotNum = res.shotNum;
        });
      }
      async function handleDelete(record) {
        let check = await preDelApi(record.id); //
        if (Array.isArray(check)) {
          return openDelListeModal(true, {
            ...record,
            option: check,
          });
        }
        createMessage.success(t('common.optSuccess'));
        reload();
        // handDelconfirm(record);
      }
      function handDelconfirm(record) {
        createConfirm({
          iconType: 'warning',
          title: '警告',
          content: `此操作将对${record.userName}进行删除, 是否继续?`,
          onOk: async () => {
            await delApi({ userId: record.id });
            reload();
          },
        });
      }
      return {
        registerTable,
        registerDetail,
        registerDelList,
        openDelListeModal,
        createMessage,
        handDelconfirm,
        t,
        reloadList: function () {
          reload();
          getNumByStaffData();
        },
        go,
        renderRoleType,
        renderStatus,
        handleCreate,
        handleOpenModal,
        register,
        handleEdit,
        handleDelete,
        uploadApi: uploadApi as any,
        RoleEnum,
        surplusSubNum,
        getCheckRole,
        getNumByStaffData,
      };
    },
  });
</script>
